if (document.getElementById("annotate_canvas") && document.getElementById("win_draggable")) {
    $("#win_draggable").toggle();
} else {
    var erase_drawing = false;
    var stop = false;
    var canvas = document.createElement("canvas");
    canvas.id = "annotate_canvas";
    canvas.width = document.body.clientWidth;
    canvas.height = $(document).height();
    document.body.appendChild(canvas);
    var draggable = document.createElement("div");
    draggable.id = "win_draggable";
    document.body.appendChild(draggable);
    $("#win_draggable").append('<div id="win_img" class="an_icon2"></div><div id="win_img2" class="an_icon3"></div><div id="annotate_tools"><a id="annotate_pointer"><img id="annotate_pointerImg" class="an_icon"  alt="Pointer" title="Pointer"></img></a><br><a id="annotate_pen"><img id="annotate_penImg" class="an_icon" alt="Pen" title="Pen" ></img></a><div class="annotate_pick">Color Picker</div><div id="annotate_color"><input id="annotate_colorSelect" type="color" value="#FF0000"></div><a id="annotate_eraser"><img id="annotate_eraserImg" class="an_icon"  alt="Eraser" title="Eraser"></img></a><br><a id="annotate_save"><img id="annotate_saveImg" class="an_icon" alt="Save" title="Save Drawing"></img></a></div><div class="annotate_size">Pen Size:</div><div class="annotate_px" id="px">4px</div><input type="range" id="annotate_thicknessSlider" value="5" max="40" min="1"></div><div id="val"></div><br><input type="button" value="Clear" id="annotate_clear" class="clear_button"><input type="button" value="Close" id="annotate_exit" class="close_button"></div><div class="annotate_about">by H. Pleitez');

    chrome.storage.sync.get({
      pen_color: '#FF0000',
      pen_thickness: 4
    }, function(items) {
      document.getElementById("annotate_thicknessSlider").value = items.pen_thickness;
      $("#annotate_colorSelect").val(items.pen_color);
    });

    document.getElementById("annotate_penImg").src=chrome.extension.getURL("tools/pen.png");
    document.getElementById("annotate_eraserImg").src=chrome.extension.getURL("tools/eraser.png");
    document.getElementById("annotate_saveImg").src=chrome.extension.getURL("tools/save.png");
    document.getElementById("annotate_pointerImg").src=chrome.extension.getURL("tools/pointer.png");
    document.getElementById("annotate_pen").style.background = "rgba(0,0,0,0.2)";

    $("#annotate_clear").click(erase);
    $("#annotate_exit").click(exit);
    $("#annotate_save").click(save);
    $("#annotate_pen").click(pen);
    $("#annotate_pointer").click(pointer);
    $("#annotate_eraser").click(eraser);
    

    $(function() {
        $("#win_draggable").draggable({distance: 8});
    });

    var ctx, flag = false,
        prevX = 0,
        currX = 0,
        prevY = 0,
        currY = 0,
        prevtouchX = 0,
        prevtouchY = 0,
        touchX = 0,
        touchY = 0;

    if($(document).height() > 32767) {
      alert("This page is not supported. Please try another webpage.");
      exit();
    }

    ctx = canvas.getContext("2d");
    var fromTop = document.body.scrollTop || document.documentElement.scrollTop;
    draggable.style.top = fromTop + "px";

    w = canvas.width;
    h = canvas.height;

    window.onscroll = function() {
      if (!stop) {
        if($(document).scrollTop() > 32767) {
          alert("Unfortunately, this page is not supported. Please try another webpage.");
          exit();
        }
        if($(document).height() != document.getElementById('annotate_canvas').height) {
          var save = ctx.getImageData(0, 0, document.body.clientWidth, $(document).height());
          document.getElementById('annotate_canvas').width = document.body.clientWidth;
          document.getElementById('annotate_canvas').height = $(document).height();
          w = document.getElementById('annotate_canvas').width;
          h = document.getElementById('annotate_canvas').height;
          ctx.putImageData(save, 0, 0);
        }
        var fromTop = document.body.scrollTop || document.documentElement.scrollTop;
        draggable.style.top = fromTop + "px";
      }
    };

    canvas.addEventListener("mousemove", function(e) {
        findxy('move', e)
    }, false);
    canvas.addEventListener("mousedown", function(e) {
        findxy('down', e)
    }, false);
    canvas.addEventListener("mouseup", function(e) {
        findxy('up', e)
    }, false);
    canvas.addEventListener("mouseout", function(e) {
        findxy('out', e)
    }, false);
    canvas.addEventListener('touchstart', sketchpad_touchStart, false);
    canvas.addEventListener('touchmove', sketchpad_touchMove, false);

    $(document).keydown(function(e) {
        if (!stop) {
            switch (e.which) {
                case 88:
                    erase();
                    break;
                case 27:
                    exit();
                    break;
            }
        }
    });

    function draw() {
      var color = document.getElementById("annotate_colorSelect").value;
      var thickness = document.getElementById("annotate_thicknessSlider").value;
        ctx.beginPath();
        if(erase_drawing) {
          ctx.globalCompositeOperation="destination-out";
          ctx.lineWidth = thickness * 1.5;
          ctx.strokeStyle = color;
          ctx.lineJoin = "round";
          ctx.moveTo(prevX, prevY);
          ctx.lineTo(currX, currY);
          ctx.closePath();
          ctx.stroke();
        } else {
          ctx.globalCompositeOperation="source-over";
          ctx.lineWidth = thickness;
          ctx.strokeStyle = color;
          ctx.lineJoin = "round";
          ctx.moveTo(prevX, prevY);
          ctx.lineTo(currX, currY);
          ctx.closePath();
          ctx.stroke();
        }
    }

    function drawTouch(x, y) {
        var thickness = document.getElementById("annotate_thicknessSlider").value;
        var color = document.getElementById("annotate_colorSelect").value;
        ctx.beginPath();
        if(erase_drawing) {
          ctx.globalCompositeOperation="destination-out";
          ctx.lineWidth = thickness * 1.5;
          ctx.strokeStyle = color;
          ctx.lineJoin = "round";
          ctx.moveTo(prevtouchX, prevtouchY);
          ctx.lineTo(x, y);
          ctx.closePath();
          ctx.stroke();
        } else {
          ctx.globalCompositeOperation="source-over";
          ctx.lineWidth = thickness;
          ctx.strokeStyle = color;
          ctx.lineJoin = "round";
          ctx.moveTo(prevtouchX, prevtouchY);
          ctx.lineTo(x, y);
          ctx.closePath();
          ctx.stroke();
        }
    }

    function save() {
      var draggable = document.getElementById("win_draggable");
      $("#win_draggable").toggle(function(){
        if(draggable.style.display=="none") {
          chrome.runtime.sendMessage({from: "content_script"}, function(response) {
            screenshot = response.screenshot
            let date = new Date();
            let fileDate = ("0" + (date.getMonth() + 1)).slice(-2).toString() + "-" + ("0" + date.getDate()).slice(-2)  + "-" + date.getFullYear();
            let fileTime = date.getHours() + ":" + ("0" + date.getMinutes()).slice(-2);
            let fileAMPM = date.gethours >= 12 ? 'am' : 'pm';
            var e = document.createElement("a");
            e.download = "Annotate_" + fileDate + "_" + fileTime + "_" + fileAMPM, e.href = screenshot, document.body.appendChild(e), e.click(),
            document.body.removeChild(e);
            var img = "<img width='100%' src='" + screenshot + "'></img>"
            var x = window.open();
            x.document.open();
            x.document.write(img);
            x.document.close();
            draggable.style.display = "block";
          });
        }
      });
    }

    function erase() {
      ctx.clearRect(0, 0, canvas.width-0.1, canvas.height-0.1);
    }

    function eraser() {
      erase_drawing = true;
      canvas.style.pointerEvents = "auto";
      document.getElementById("annotate_pen").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_pointer").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_eraser").style.background =  "rgba(0,0,0,0.2)";
    }

    function pen() {
      erase_drawing = false;
      canvas.style.pointerEvents = "auto";
      document.getElementById("annotate_eraser").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_pointer").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_pen").style.background =  "rgba(0,0,0,0.2)";
    }

    function pointer() {
      if(canvas.style.pointerEvents == "none") {
        canvas.style.pointerEvents = "auto";
      } else {
        canvas.style.pointerEvents = "none";
      }
      document.getElementById("annotate_pen").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_eraser").style.background =  "rgba(0,0,0,0)";
      document.getElementById("annotate_pointer").style.background =  "rgba(0,0,0,0.2)";
    }

    function exit() {
        document.getElementById("annotate_canvas").remove();
        document.getElementById("win_draggable").remove();
        canvas.removeEventListener("mousemove", function(e) {
            findxy('move', e)
        }, false);
        canvas.removeEventListener("mousedown", function(e) {
            findxy('down', e)
        }, false);
        canvas.removeEventListener("mouseup", function(e) {
            findxy('up', e)
        }, false);
        canvas.removeEventListener("mouseout", function(e) {
            findxy('out', e)
        }, false);
        canvas.removeEventListener('touchstart', sketchpad_touchStart, false);
        canvas.removeEventListener('touchmove', sketchpad_touchMove, false);
        stop = true;
    }

    function findxy(res, e) {
        if (res == 'down') {
            prevX = currX;
            prevY = currY;
            currX = e.pageX - canvas.offsetLeft;
            currY = e.pageY - canvas.offsetTop;
            var thickness = document.getElementById("annotate_thicknessSlider").value;
            ctx.beginPath();
            var color = document.getElementById("annotate_colorSelect").value;
            if(!erase_drawing) {
              ctx.globalCompositeOperation="source-over";
              ctx.strokeStyle = color;
              ctx.lineWidth = thickness;
              ctx.lineJoin = "round";
              ctx.moveTo(currX, currY-0.0006);
              ctx.lineTo(currX, currY);
            } else {
              ctx.globalCompositeOperation="destination-out";
              ctx.lineWidth = thickness * 1.5;
              ctx.lineJoin = "round";
              ctx.moveTo(currX, currY-0.0006);
              ctx.lineTo(currX, currY);
            }
            ctx.closePath();
            ctx.stroke();
            flag = true;
        }
        if (res == 'up' || res == "out") {
            flag = false;
        }
        if (res == 'move') {
            if (flag) {
                prevX = currX;
                prevY = currY;
                currX = e.pageX - canvas.offsetLeft;
                currY = e.pageY - canvas.offsetTop;
                draw();
            }
        }
    }

    function getTouchPos(e) {
        if (!e)
            var e = event;
        if (e.touches) {
            if (e.touches.length == 1) {
                prevtouchX = touchX;
                prevtouchY = touchY;
                var touch = e.touches[0];
                touchX = touch.pageX - touch.target.offsetLeft;
                touchY = touch.pageY - touch.target.offsetTop;
            }
        }
    }

    function sketchpad_touchStart() {
        getTouchPos();
        prevtouchX = touchX;
        prevtouchY = touchY;
        drawTouch(touchX, touchY);
        event.preventDefault();
    }

    function sketchpad_touchMove(e) {
        getTouchPos();
        drawTouch(touchX, touchY);
        event.preventDefault();
    }
}
$('input[type=range]').on('input', function () {
  document.getElementById('px').innerHTML=document.getElementById("annotate_thicknessSlider").value + "px";
});
